#define CONTYPE_NONE    0
#define CONTYPE_INT     1
#define CONTYPE_FLOAT   2
#define CONTYPE_STRING  3
#define CONTYPE_MACRO   4
#define CONTYPE_UNKNOWN 5

#define SKIP_NONE       0
#define SKIP_LINE       1
#define SKIP_MODE       2

typedef struct ConInfoS {
    struct ConInfoS *next;
    char *str;
    char *str1;
    LinkT *tokenlist;
    int type;
    int value;
} ConInfoT;

void InitDirect(void);
void PrintConstants(void);
int EvaluateNumber(char **tokens, int num);
LinkT *ExpandLine(LinkT *tokenlist);
int GetConstantTypeList(LinkT *tokenlist, double *fval, int *ival);
void AddToConList(char *str, LinkT *tokenlist, int type);
int ProcessDirective(LinkT *tokenlist);
int ProcessIncludeDirective(LinkT *tokenlist);
ConInfoT *DestroyConList(ConInfoT *coninfo);
